/* Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991. All
rights reserved.

License to copy and use this software is granted provided that it
is identified as the "RSA Data Security, Inc. MD5 Message-Digest
Algorithm" in all material mentioning or referencing this software
or this function.

License is also granted to make and use derivative works provided
that such works are identified as "derived from the RSA Data
Security, Inc. MD5 Message-Digest Algorithm" in all material
mentioning or referencing the derived work.

RSA Data Security, Inc. makes no representations concerning either
the merchantability of this software or the suitability of this
software for any particular purpose. It is provided "as is"
without express or implied warranty of any kind.

These notices must be retained in any copies of any part of this
documentation and/or software.
 */

#ifndef _MD5_H_
#define _MD5_H_

/* MD5 context. */
typedef struct MD5Context {
    ULONG state[4];		/* state (ABCD) */
/*    u_int64_t count;		/ number of bits, modulo 2^64 / */
    ULONG count;		/* number of bits, modulo 2^32 */
    unsigned char buffer[64];	/* input buffer */
} MD5_CTX;

void   APIENTRY MD5Init(MD5_CTX *);
void   APIENTRY MD5Update(MD5_CTX *, const unsigned char *, ULONG);
void   APIENTRY MD5Final(unsigned char [16], MD5_CTX *);
void   APIENTRY MD5Transform(ULONG [4], const unsigned char [64]);
char * APIENTRY MD5End(MD5_CTX *, char *);
char * APIENTRY MD5File(char *, char *);
char * APIENTRY MD5Data(const unsigned char *, ULONG, char *);

#endif /* _MD5_H_ */
